# DYMO4PB
-----


## overview
Use DYMO Labelwriter with PureBasic. DYMO4PB provides simple access to the DYMO-SDK with COMatePlus:

*	examine available DYMO printers
*	open / save label from file
*	open / save label from memory
*	modify and print loaded labels
*	change text / address / barcode / graphic
*	smart paste from clipboard / file / string
*	create printjobs for faster printing
*	manage MRU-Labels (Most Recently Used)
*	create DLL


-----


## what you need
* 	[DYMO Label Software](dymo.com) (DLS) have to be installed. This Include is created for DLS v.8+ (year 2015+). Maybe it works with lower version, but this is untested.
* 	COMatePlus - Version 1.2 included (2010-06-09) (different author & license, see COMatePLUS.chm).

-----

## example:

```
DYMO_Init()	; Use this BEFORE any use of DYMO_*() commands.

DYMO_OpenLabel("MyLabelFile.label")
DYMO_SetField("TextField", "My Text")
DYMO_SetImageFile("Logo", "MyLogo.bmp")
DYMO_PrintLabel()

DYMO_Release()
```

All functions are described in the include file "DYMO.pbi".

---	
## create DLL
If you want to use the DLL, simple compile "DYMO_CreateDLL.pb" and include "DYMO_DLL.pbi"